import axipy
from axipy import view_manager, data_manager
import axipy
from axipy import TextStyle, TextAlignment, Geometry, Pnt, LineString, Line, Point, MultiPoint, Polygon, MultiPolygon, \
    data_manager, Feature, LabelLayoutPosition


class LabelToText:
    def __init__(self,map_view,label_property_layer):
        self.__active_map_view=map_view
        self.__label_property_layer=label_property_layer
        self.__textStyle=None
        self.__init_base_styleText()
    def __init_base_styleText(self):
        font=self.__label_property_layer.font
        name_font=font.family()
        size_font=font.pointSize()
        self.__textStyle=TextStyle(name_font,size_font)
        self.__textStyle.fontname=name_font
        self.__textStyle.color=self.__label_property_layer.color
        self.__textStyle.bg_color=self.__label_property_layer.backgroundColor
        self.__textStyle.bold=font.bold()
        self.__textStyle.alignment=TextAlignment.Center
        self.__textStyle.italic=font.italic()
    def createText(self,text_label,geometry_obj:Geometry):
        pt_center=geometry_obj.centroid()
        pnt_start_text=Pnt(pt_center.x,pt_center.y)
        text = axipy.Text.create_by_style(text_label, pnt_start_text, self.__textStyle,self.__active_map_view,cs=geometry_obj.coordsystem)
        bound_width=text.bounds.width
        bound_height=text.bounds.height
        label_Layout=None
        if isinstance(geometry_obj,LineString) or isinstance(geometry_obj,Line):
            label_Layout=self.__label_property_layer.lineLayout
        if isinstance(geometry_obj,Point) or isinstance(geometry_obj,MultiPoint):
            label_Layout=self.__label_property_layer.pointLayout
        if isinstance(geometry_obj,Polygon) or isinstance(geometry_obj,MultiPolygon):
            label_Layout=self.__label_property_layer.areaLayout
        pnt_start_text_new=None
        layout_position=label_Layout.position
        if layout_position==LabelLayoutPosition.Center:
            pnt_start_text_new=Pnt(pnt_start_text.x-bound_width/2,pnt_start_text.y+bound_height/2)
        if layout_position==LabelLayoutPosition.Bottom:
            pnt_start_text_new = Pnt(pnt_start_text.x - bound_width/2, pnt_start_text.y)
        if layout_position==LabelLayoutPosition.BottomLeft:
            pnt_start_text_new = Pnt(pnt_start_text.x - bound_width, pnt_start_text.y)
        if layout_position==LabelLayoutPosition.BottomRight:
            pnt_start_text_new = None
        if layout_position==LabelLayoutPosition.Left:
            pnt_start_text_new = Pnt(pnt_start_text.x - bound_width, pnt_start_text.y+bound_height/2)
        if layout_position==LabelLayoutPosition.Right:
            pnt_start_text_new = Pnt(pnt_start_text.x , pnt_start_text.y+bound_height/2)
        if layout_position==LabelLayoutPosition.Top:
            pnt_start_text_new = Pnt(pnt_start_text.x -bound_width/2, pnt_start_text.y+bound_height)
        if layout_position==LabelLayoutPosition.TopLeft:
            pnt_start_text_new = Pnt(pnt_start_text.x -bound_width, pnt_start_text.y+bound_height)
        if layout_position==LabelLayoutPosition.TopRight:
            pnt_start_text_new = Pnt(pnt_start_text.x, pnt_start_text.y+bound_height)
        if pnt_start_text_new is not None:
            text.startPoint=pnt_start_text_new
        return text
def buildTextTable(active_map,layer,tab_out,col_name_value):
    cls_text_obj=LabelToText(active_map,layer.label)
    text_label=layer.label.text
    data_source=layer.data_object
    sql="select "+text_label+" as label,obj from "+data_source.name
    query=data_manager.query_hidden(sql)
    for ft in query:
        value_label=ft['label']
        text_obj=cls_text_obj.createText(value_label,ft.geometry)
        ft=Feature({col_name_value:value_label},geometry=text_obj)
        tab_out.insert([ft])
    query.close()



layer_select=[]
for lc in axipy.view_manager.layer_controls:
    if lc.selected_layers:
        for l in lc.selected_layers:
            layer_select.append(l)
if len(layer_select)>0:
    name_tab='_11_piket__label'
    name_col_value='value_text'
    tab_out=data_manager.find(name_tab)
    active_map_view=view_manager.active
    buildTextTable(active_map_view,layer_select[0],tab_out,name_col_value)