import os
import time

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog
from axipy import view_manager, Layer

from ru_axioma_gis_label_to_text.ui.tools.task_label_to_text import TaskLabelToText


class RunLabelToText(QDialog):
    def __init__(self,layer,parent=None):
        super().__init__(parent)
        self.__layer_with_label=layer
        self.__ui=self.load_ui("dlg_run.ui",parent)
        self.__ui.pb_cancel.clicked.connect(self.__cancel)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __run(self,mapView):
        self.__cls_run=TaskLabelToText(mapView,self.__layer_with_label,self.__tab_out)
        self.__run_task()
        #self.__ui.close()
    def __run_task(self):
        activeMap=view_manager.active
        #self.__cls_run = TaskLabelToText(activeMap,self.__layer_with_label,self.__tab_out)
        self.__cls_run.change_progress.connect(self.__update_progess_bar)
        def run_process(t: axipy.Task):
            self.__cls_run.run()
        self.__run_task = axipy.Task(run_process)
        self.__run_task.finished.connect(self.__finish_task)
        self.__run_task.start()
    def __update_progess_bar(self,value):
        self.__ui.progressBar.setValue(value)

    def __finish_task(self):
        self.__cls_run.change_progress.disconnect(self.__update_progess_bar)
        self.__run_task = None
        axipy.mainwindow.add_layer_interactive(Layer.create(self.__tab_out))
        self.__cls_run=None
        self.__ui.close()
    def __cancel(self):
        if self.__cls_run is not None:
            self.__cls_run.setCancel()
    def exec_(self,mapView,layer,tab_out_label):
        self.__layer_with_label=layer
        self.__tab_out=tab_out_label
        self.__ui.show()
        self.__run(mapView)