from pathlib import Path

import axipy
from axipy import provider_manager, Schema, Attribute


class TableCache:
    def __init__(self,out_tab,size_cache=100):
        self.__table=out_tab
        self.__size_cache=size_cache
        self.__cache=[]
    def insert(self,ft_insert):

        self.__cache.append(ft_insert)
        if len(self.__cache)>self.__size_cache:
            self.__table.insert(self.__cache)
            self.__cache.clear()
    def end(self):
        if len(self.__cache) > 0:
            self.__table.insert(self.__cache)
            self.__cache.clear()
def getPathOutTable(source_data_source,sufix):
    if isinstance(source_data_source,axipy.QueryTable):
        return None
    if isinstance(source_data_source,axipy.Table):
        path_file_name=source_data_source.file_name

        return getPathFileBySufix(path_file_name,sufix)
    return None
def getPathFileBySufix(path_source:Path,sufix):
    out_path=path_source.parent
    name=path_source.stem
    base_out_file=name+sufix
    for i in range(100):
        id_str=''
        if i>0:
            id_str="_"+str(i)
        path_tab=out_path.joinpath(base_out_file+id_str+".tab")
        if not path_tab.exists():
            return str(path_tab)
        try:
            provider_manager.tab.remove_table_files(str(path_tab))
            return str(path_tab)
        except:
            pass
    return None
def createTableForLabel(path_label,cs,name_col="text_value"):
    schema = Schema(

        Attribute.integer('id'),
        Attribute.string(name_col,254),

        coordsystem=cs
    )
    definition = {
        'src': path_label,
        'schema': schema
    }
    table = provider_manager.create(definition)
    return table