import axipy
from axipy import view_manager, MapView, Observer


def findLayerControl(map_view):
    for lc in axipy.view_manager.layer_controls:
        if map_view==lc.active_map_view:
            return lc
        if map_view.title==lc.active_map_view.title:
            return lc
    return None
class ObserverLayerSelect:
    def __init__(self):
        self.__active_map_view=None
        self.__layer_control=None
        self.__observer=factoryObserver("select_layer")
        self.__observer.value=False
        view_manager.active_changed.connect(self.__change_active)
    def __change_active(self):
        if isinstance(view_manager.active,MapView):
            self.__active_map_view=view_manager.active
            self.__layer_control=findLayerControl(self.__active_map_view)
            self.__layer_control.selection_changed.connect(self.__change_selection)
        else:
            if self.__layer_control is not None:
                self.__layer_control.selection_changed.didconnect(self.__change_selection)
                self.__layer_control=None
    def __change_selection(self):
        count=len(self.__layer_control.selected_layers)
        self.__observer.value=True
def factoryObserver(name_observer):
    observer = axipy.observer_manager.get(name_observer)
    if observer is not None:
        return observer
    observer = Observer(name_observer, False)
    def changeActiveView():
        if isinstance(view_manager.active,MapView):
            observer.value=True
        else:
            observer.value=False
        return

    setattr(observer, "changeActiveView", changeActiveView)
    # setattr(observer, "changeView", changeView)

    axipy.view_manager.active_changed.connect(observer.changeActiveView)

    changeActiveView()
    return observer
def getSelectLayerInLayerControl(map_view):
    layer_select = []
    for lc in axipy.view_manager.layer_controls:
        if lc.active_map_view.title==map_view.title:
            if lc.selected_layers:
                for l in lc.selected_layers:
                    layer_select.append(l)
    if len(layer_select)==0:
        return None
    return layer_select