from PySide2.QtCore import QObject, Signal
from axipy import data_manager, Feature, TypeSqlDialect

from ru_axioma_gis_label_to_text.ui.tools.helper_tab import TableCache
from ru_axioma_gis_label_to_text.ui.tools.label_to_tab import LabelToText
class CalcIntProcent:
    def __init__(self,count):
        self.__last_proc=-1
        self.__count=count
    def getValue(self,curent):
        cur_val=int((curent/self.__count)*100+0.5)
        if cur_val==self.__last_proc:
            return None
        self.__last_proc=cur_val
        return cur_val


class TaskLabelToText(QObject):
    change_progress=Signal(int)

    def __init__(self,active_map,layer,tab_out,col_name_value="text_value"):
        super().__init__()
        self.__mapView=active_map
        self.__layer=layer
        self.__tab_out=tab_out
        self.__col_name=col_name_value
        self.__isCancel=False
    def run(self):
        #print("Start run")
        cls_text_obj = LabelToText(self.__mapView, self.__layer.label)
        text_label = self.__layer.label.text

        data_source =self.__layer.data_object
        #print(data_source.name)
        sql = "select " + text_label + " as label,obj from " + data_source.name
        #print(sql)
        query = data_manager.query_hidden(sql,TypeSqlDialect.axioma)
        count_ft=query.count()
        #print(count_ft)
        if count_ft==0:
            query.close()
            return
        cls_cache = TableCache(self.__tab_out, 1000)
        calc_procent=CalcIntProcent(count_ft)
        for i,ft in enumerate(query):
            if self.__isCancel:
                break
            value_label = ft['label']
            proc=calc_procent.getValue(i+1)
            if proc is not None:
                self.change_progress.emit(proc)
            if ft.geometry is None:
                continue
            text_obj = cls_text_obj.createText(value_label, ft.geometry)
            ft = Feature({self.__col_name: value_label}, geometry=text_obj,style=cls_text_obj.styleText)
            # tab_out.insert([ft])
            cls_cache.insert(ft)
        #print("End 0")
        cls_cache.end()
        #print("End ")
        query.close()
        #print("Close query")
        return
    def setCancel(self):
        self.__isCancel=True

